#include <bits/stdc++.h>

using namespace std;

int tokReke[100][100];

int main()
{
    int n, h, br = 0, stene; cin>>h>>n;

    for(int i = 0; i < h; i++)
    {
        for(int j = 0; j < n; j++)
        {
            cin>>stene;
            if(i == 0) tokReke[j][i]++;
            else tokReke[j][i] += tokReke[j][i-1];

            int ukupanTok = 0;

            if(stene == 0)
            {
                br++;
                if(j == n - 1)
                {
                    for(int k = 0; k < br; k++)
                    {
                        ukupanTok += tokReke[j-k][i];
                        tokReke[j-k][i] = 0;
                    }

                    tokReke[j-br][i] += ukupanTok;
                    br = 0;
                }

            }
            else if(br >= 1)
            {

                for(int k = 1; k <= br; k++)
                {
                     ukupanTok += tokReke[j-k][i];
                     tokReke[j-k][i] = 0;
                }

                if((i+1)%2 == 1)
                {
                    if(j-br == 0) tokReke[j][i] += ukupanTok;
                    else
                    {
                        if(ukupanTok%2 == 1) tokReke[j-1-br][i] += ukupanTok/2 + 1;
                        else tokReke[j-1-br][i] += ukupanTok/2;

                        tokReke[j][i] += ukupanTok/2;
                    }
                }
                else
                {

                    if(j-br == 0) tokReke[j][i] += ukupanTok;
                    else
                    {
                        if(ukupanTok%2 == 1) tokReke[j][i] += ukupanTok/2 + 1;
                        else tokReke[j][i] += ukupanTok/2;

                        tokReke[j-1-br][i] += ukupanTok/2;
                    }
                }

               br = 0;
            }
        }
    }

    for(int i = 0; i < n; i++) cout<<tokReke[i][h-1]<<" ";

    return 0;
}